"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _css() {
  const data = require("@emotion/css");
  _css = function _css() {
    return data;
  };
  return data;
}
function _antd() {
  const data = require("@formily/antd");
  _antd = function _antd() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
function _client2() {
  const data = require("@nocobase/evaluators/client");
  _client2 = function _client2() {
    return data;
  };
  return data;
}
function _client3() {
  const data = require("@nocobase/utils/client");
  _client3 = function _client3() {
    return data;
  };
  return data;
}
function _antd2() {
  const data = require("antd");
  _antd2 = function _antd2() {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _reactI18next() {
  const data = require("react-i18next");
  _reactI18next = function _reactI18next() {
    return data;
  };
  return data;
}
var _FlowContext = require("../FlowContext");
var _RadioWithTooltip = require("../components/RadioWithTooltip");
var _renderEngineReference = require("../components/renderEngineReference");
var _locale = require("../locale");
var _variable = require("../variable");
const _excluded = ["node", "insert"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function matchDynamicExpressionCollectionField(field) {
  const _useCollectionManager = (0, _client().useCollectionManager)(),
    getCollectionFields = _useCollectionManager.getCollectionFields,
    getCollection = _useCollectionManager.getCollection;
  if (field.type !== 'belongsTo') {
    return false;
  }
  const fields = getCollectionFields(field.target);
  return fields.some(f => f.interface === 'expression');
}
const DynamicConfig = ({
  value,
  onChange: _onChange
}) => {
  const _useTranslation = (0, _reactI18next().useTranslation)(),
    t = _useTranslation.t;
  const scope = (0, _variable.useWorkflowVariableOptions)([matchDynamicExpressionCollectionField]);
  return _react().default.createElement(_antd().FormLayout, {
    layout: "vertical"
  }, _react().default.createElement(_antd().FormItem, {
    label: t('Expression type', {
      ns: _locale.NAMESPACE
    })
  }, _react().default.createElement(_antd2().Radio.Group, {
    value: value === false ? false : value || null,
    onChange: ev => {
      _onChange(ev.target.value);
    }
  }, _react().default.createElement(_antd2().Radio, {
    value: false
  }, t('Static', {
    ns: _locale.NAMESPACE
  })), _react().default.createElement(_antd2().Radio, {
    value: value || null
  }, t('Dynamic', {
    ns: _locale.NAMESPACE
  })))), value !== false ? _react().default.createElement(_antd().FormItem, {
    label: t('Select dynamic expression', {
      ns: _locale.NAMESPACE
    })
  }, _react().default.createElement(_client().Variable.Input, {
    value: value || null,
    onChange: v => _onChange(v),
    scope: scope
  })) : null);
};
function useWorkflowVariableEntityOptions() {
  return (0, _variable.useWorkflowVariableOptions)([{
    type: 'reference',
    options: {
      collection: '*',
      entity: true
    }
  }]);
}
var _default = {
  title: `{{t("Calculation", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'calculation',
  group: 'control',
  fieldset: {
    dynamic: {
      type: 'string',
      'x-component': 'DynamicConfig',
      default: false
    },
    engine: {
      type: 'string',
      title: `{{t("Calculation engine", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'RadioWithTooltip',
      'x-component-props': {
        options: (0, _client2().getOptions)()
      },
      required: true,
      default: 'math.js',
      'x-reactions': {
        dependencies: ['dynamic'],
        fulfill: {
          state: {
            visible: '{{$deps[0] === false}}'
          }
        }
      }
    },
    expression: {
      type: 'string',
      title: `{{t("Calculation expression", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Variable.TextArea',
      'x-component-props': {
        scope: '{{useWorkflowVariableOptions}}'
      },
      ['x-validator'](value, rules, {
        form
      }) {
        const values = form.values;
        const _evaluators$get = _client2().evaluators.get(values.engine),
          evaluate = _evaluators$get.evaluate;
        const exp = value.trim().replace(/{{([^{}]+)}}/g, ' 1 ');
        try {
          evaluate(exp);
          return '';
        } catch (e) {
          return (0, _locale.lang)('Expression syntax error');
        }
      },
      'x-reactions': [{
        dependencies: ['dynamic'],
        fulfill: {
          state: {
            visible: '{{$deps[0] === false}}'
          }
        }
      }, {
        dependencies: ['engine'],
        fulfill: {
          schema: {
            description: '{{renderEngineReference($deps[0])}}'
          }
        }
      }],
      required: true
    },
    scope: {
      type: 'string',
      title: `{{t("Variable datasource", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Variable.Input',
      'x-component-props': {
        scope: '{{useWorkflowVariableEntityOptions}}'
      },
      'x-reactions': {
        dependencies: ['dynamic'],
        fulfill: {
          state: {
            visible: '{{$deps[0] !== false}}'
          }
        }
      }
    }
  },
  view: {},
  scope: {
    useWorkflowVariableOptions: _variable.useWorkflowVariableOptions,
    useWorkflowVariableEntityOptions,
    renderEngineReference: _renderEngineReference.renderEngineReference
  },
  components: {
    CalculationResult({
      dataSource
    }) {
      var _execution$jobs;
      const _useFlowContext = (0, _FlowContext.useFlowContext)(),
        execution = _useFlowContext.execution;
      if (!execution) {
        return (0, _locale.lang)('Calculation result');
      }
      const result = (0, _client3().parse)(dataSource)({
        $jobsMapByNodeId: ((_execution$jobs = execution.jobs) !== null && _execution$jobs !== void 0 ? _execution$jobs : []).reduce((map, job) => Object.assign(map, {
          [job.nodeId]: job.result
        }), {})
      });
      return _react().default.createElement("pre", {
        className: (0, _css().css)`
            margin: 0;
          `
      }, JSON.stringify(result, null, 2));
    },
    RadioWithTooltip: _RadioWithTooltip.RadioWithTooltip,
    DynamicConfig
  },
  getOptions(config, types) {
    if (types && !types.some(type => type in _variable.BaseTypeSets || Object.values(_variable.BaseTypeSets).some(set => set.has(type)))) {
      return null;
    }
    return [
      // { key: '', value: '', label: lang('Calculation result') }
    ];
  },
  useInitializers(node) {
    var _node$title;
    return {
      type: 'item',
      title: (_node$title = node.title) !== null && _node$title !== void 0 ? _node$title : `#${node.id}`,
      component: CalculationInitializer,
      node
    };
  }
};
exports.default = _default;
function CalculationInitializer(_ref) {
  let node = _ref.node,
    insert = _ref.insert,
    props = _objectWithoutProperties(_ref, _excluded);
  return _react().default.createElement(_client().SchemaInitializer.Item, _objectSpread(_objectSpread({}, props), {}, {
    onClick: () => {
      var _node$title2;
      insert({
        type: 'void',
        name: node.id,
        title: node.title,
        'x-component': 'CardItem',
        'x-component-props': {
          title: (_node$title2 = node.title) !== null && _node$title2 !== void 0 ? _node$title2 : `#${node.id}`
        },
        'x-designer': 'SimpleDesigner',
        properties: {
          result: {
            type: 'void',
            'x-component': 'CalculationResult',
            'x-component-props': {
              // NOTE: as same format as other reference for migration of revision
              dataSource: `{{$jobsMapByNodeId.${node.id}}}`
            }
          }
        }
      });
    }
  }));
}