"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.values = exports.filter = exports.collection = exports.appends = void 0;
function _css() {
  const data = require("@emotion/css");
  _css = function _css() {
    return data;
  };
  return data;
}
function _react() {
  const data = require("@formily/react");
  _react = function _react() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _locale = require("../locale");
const collection = {
  type: 'string',
  title: '{{t("Collection")}}',
  required: true,
  'x-reactions': ['{{useCollectionDataSource()}}'],
  'x-decorator': 'FormItem',
  'x-component': 'Select',
  'x-component-props': {
    dropdownMatchSelectWidth: false,
    placeholder: '{{t("Select collection")}}'
  }
};
exports.collection = collection;
const values = {
  type: 'object',
  title: '{{t("Fields values")}}',
  'x-decorator': 'FormItem',
  'x-decorator-props': {
    labelAlign: 'left',
    className: (0, _css().css)`
      flex-direction: column;
    `
  },
  'x-component': 'CollectionFieldset',
  description: `{{t("Fields that are not assigned a value will be set to the default value, and those that do not have a default value are set to null.", { ns: "${_locale.NAMESPACE}" })}}`
};
exports.values = values;
const filter = {
  type: 'object',
  title: '{{t("Filter")}}',
  'x-decorator': 'FormItem',
  'x-component': 'Filter',
  'x-component-props': {
    useProps() {
      const _useForm = (0, _react().useForm)(),
        values = _useForm.values;
      const options = (0, _client().useCollectionFilterOptions)(values === null || values === void 0 ? void 0 : values.collection);
      return {
        options,
        className: (0, _css().css)`
          position: relative;
          width: 100%;
        `
      };
    },
    dynamicComponent: 'FilterDynamicComponent'
  }
};
exports.filter = filter;
const appends = {
  type: 'array',
  title: `{{t("Preload associations", { ns: "${_locale.NAMESPACE}" })}}`,
  description: `{{t("Only configured association field could be accessed in following nodes", { ns: "${_locale.NAMESPACE}" })}}`,
  'x-decorator': 'FormItem',
  'x-component': 'FieldsSelect',
  'x-component-props': {
    mode: 'multiple',
    placeholder: '{{t("Select Field")}}',
    filter(field) {
      return ['linkTo', 'belongsTo', 'hasOne', 'hasMany', 'belongsToMany'].includes(field.type);
    }
  },
  'x-reactions': [{
    dependencies: ['collection'],
    fulfill: {
      state: {
        visible: '{{!!$deps[0]}}'
      }
    }
  }]
};
exports.appends = appends;